#!/usr/bin/env make -f

#-------------------------------------------------------------------------------
# Project Config
#-------------------------------------------------------------------------------

include config.mk

#-------------------------------------------------------------------------------
# General
#-------------------------------------------------------------------------------
SHELL          := /bin/sh

INSTALL         = /usr/bin/install
INSTALL_PROGRAM = $(INSTALL)
INSTALL_DATA    = $(INSTALL) -m 644
SED             = sed
RM             := rm -f
CP              = cp
MKDIR           = mkdir

INKSCAPE       := $(shell command -v inkscape 2> /dev/null)
YELP_BUILD     := $(shell command -v yelp-build 2> /dev/null)

#-------------------------------------------------------------------------------
# Usefull defines & functions
#-------------------------------------------------------------------------------
define \n


endef

#-------------------------------------------------------------------------------
# Path variables
#-------------------------------------------------------------------------------
topdir          = $(abspath $(dir $(firstword $(MAKEFILE_LIST))))

prefix          = /usr/local
libdir          = /lib
bindir          = /bin
sharedir        = /share
appdatadir      = /share/appdata
applicationsdir = /share/applications
gschemasdir     = /share/glib-2.0/schemas
iconsdir        = /share/icons
localedir       = /share/locale
datadir         = /share/$(PACKAGE)

builddir        = build
srcdir          = src
srcdatadir      = data

#-------------------------------------------------------------------------------
# Build variables
#-------------------------------------------------------------------------------

# Search paths, first builddir then srcdir
VPATH = $(builddir):$(srcdir):$(srcdatadir)

BUILD_LIB       =
BUILD_BIN       =
BUILD_DATA      =
BUILD_ICONS     =
BUILD_CLEAN     =

#-------------------------------------------------------------------------------
# Compile variables
#-------------------------------------------------------------------------------
CC             := cc
CFLAGS          = -Werror #-Wall -Wextra -Wstrict-prototypes -g
LDFLAGS         =
LDLIBS          =

GLIB_COMPILE_RESOURCES  = glib-compile-resources
GLIB_COMPILE_SCHEMA     = glib-compile-schemas
GTK_UPDATE_ICON_CACHE   = gtk-update-icon-cache
UPDATE_DESKTOP_DATABASE = update-desktop-database
