#include "dark-theme.h"

#include <glib/gi18n.h>
#include <glib-object.h>

struct _BoilerplatePluginDarkTheme
{
    PeasExtensionBase parent;
};

static void boilerplate_activatable_iface_init (BoilerplateActivatableInterface *iface);

G_DEFINE_DYNAMIC_TYPE_EXTENDED (BoilerplatePluginDarkTheme,
                                boilerplate_plugin_dark_theme,
                                PEAS_TYPE_EXTENSION_BASE,
                                0,
                                G_IMPLEMENT_INTERFACE_DYNAMIC (GTD_TYPE_ACTIVATABLE, boilerplate_activatable_iface_init))

enum {
    PROP_0,
    PROP_PREFERENCES_PANEL,
    N_PROPS
};

/*
 * BoilerplateActivatable interface implementation
 */
static void                          // PeasActivatable *plugin   ????????
boilerplate_plugin_dark_theme_activate (BoilerplateActivatable *activatable)
{
    g_object_set (gtk_settings_get_default (),
                  "gtk-application-prefer-dark-theme", TRUE,
                  NULL);
}

static void
boilerplate_plugin_dark_theme_deactivate (BoilerplateActivatable *activatable)
{
    g_object_set (gtk_settings_get_default (),
                  "gtk-application-prefer-dark-theme", FALSE,
                  NULL);
}

static void
boilerplate_activatable_iface_init (BoilerplateActivatableInterface *iface)
{
    iface->activate = boilerplate_plugin_dark_theme_activate;
    iface->deactivate = boilerplate_plugin_dark_theme_deactivate;
}

static void
boilerplate_plugin_dark_theme_get_property (GObject    *object,
                                            guint       prop_id,
                                            GValue     *value,
                                            GParamSpec *pspec)
{
    switch (prop_id)
    {
        case PROP_PREFERENCES_PANEL:
            g_value_set_object (value, NULL);
            break;

        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
    }
}

static void
boilerplate_plugin_dark_theme_class_init (BoilerplatePluginDarkThemeClass *klass)
{
    GObjectClass *object_class = G_OBJECT_CLASS (klass);

    object_class->get_property = boilerplate_plugin_dark_theme_get_property;

    g_object_class_override_property (object_class,
                                      PROP_PREFERENCES_PANEL,
                                      "preferences-panel");
}

static void
boilerplate_plugin_dark_theme_init (BoilerplatePluginDarkTheme *self)
{
}

static void
boilerplate_plugin_dark_theme_class_finalize (BoilerplatePluginDarkThemeClass *klass)
{
}

G_MODULE_EXPORT void
boilerplate_plugin_dark_theme_register_types (PeasObjectModule *module)
{
    boilerplate_plugin_dark_theme_register_type (G_TYPE_MODULE (module));

    peas_object_module_register_extension_type (module,
                                                GTD_TYPE_ACTIVATABLE,
                                                GTD_TYPE_PLUGIN_DARK_THEME);
}

